Index: trunk/client/modules/Elezioni/grafici/jpgraph_gantt.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_gantt.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_gantt.php	(revision 265)
@@ -2917,12 +3026,12 @@
     public $iConstrainArrowType;
 
-//---------------
-// CONSTRUCTOR
-    function GanttConstraint($aRow,$aType,$aColor,$aArrowSize,$aArrowType){
-	$this->iConstrainType = $aType;
-	$this->iConstrainRow = $aRow;
-	$this->iConstrainColor=$aColor;
-	$this->iConstrainArrowSize=$aArrowSize;
-	$this->iConstrainArrowType=$aArrowType;
+    //---------------
+    // CONSTRUCTOR
+    function __construct($aRow,$aType,$aColor,$aArrowSize,$aArrowType){
+        $this->iConstrainType = $aType;
+        $this->iConstrainRow = $aRow;
+        $this->iConstrainColor=$aColor;
+        $this->iConstrainArrowSize=$aArrowSize;
+        $this->iConstrainArrowType=$aArrowType;
     }
 }
@@ -2936,32 +3045,32 @@
     public $title,$caption;
     public $csimarea='',$csimtarget='',$csimwintarget='',$csimalt='';
-    public $constraints = array();    
+    public $constraints = array();
     public $iCaptionMargin=5;
     public $iConstrainPos=array();
-    protected $iStart="";				// Start date
-    public $iVPos=0;					// Vertical position
-    protected $iLabelLeftMargin=2;	// Title margin
-		
-    function GanttPlotObject() {
- 	$this->title = new TextProperty();
-	$this->title->Align("left","center");
-	$this->caption = new TextProperty();
+    protected $iStart="";    // Start date
+    public $iVPos=0;     // Vertical position
+    protected $iLabelLeftMargin=2; // Title margin
+
+    function __construct() {
+        $this->title = new TextProperty();
+        $this->title->Align('left','center');
+        $this->caption = new TextProperty();
     }
 
     function GetCSIMArea() {
-	return $this->csimarea;
+        return $this->csimarea;
     }
 
     function SetCSIMTarget($aTarget,$aAlt='',$aWinTarget='') {
-	if( !is_string($aTarget) ) {
-	    $tv = substr(var_export($aTarget,true),0,40);
-	    JpGraphError::RaiseL(6024,$tv);
-//('CSIM Target must be specified as a string.'."\nStart of target is:\n$tv");
-	}
-	if( !is_string($aAlt) ) {
-	    $tv = substr(var_export($aAlt,true),0,40);
-	    JpGraphError::RaiseL(6025,$tv);
-//('CSIM Alt text must be specified as a string.'."\nStart of alt text is:\n$tv");
-	}
+        if( !is_string($aTarget) ) {
+            $tv = substr(var_export($aTarget,true),0,40);
+            JpGraphError::RaiseL(6024,$tv);
+            //('CSIM Target must be specified as a string.'."\nStart of target is:\n$tv");
+        }
+        if( !is_string($aAlt) ) {
+            $tv = substr(var_export($aAlt,true),0,40);
+            JpGraphError::RaiseL(6025,$tv);
+            //('CSIM Alt text must be specified as a string.'."\nStart of alt text is:\n$tv");
+        }
 
         $this->csimtarget=$aTarget;
@@ -2969,56 +3078,50 @@
         $this->csimalt=$aAlt;
     }
-    
+
     function SetCSIMAlt($aAlt) {
-	if( !is_string($aAlt) ) {
-	    $tv = substr(var_export($aAlt,true),0,40);
-	    JpGraphError::RaiseL(6025,$tv);
-//('CSIM Alt text must be specified as a string.'."\nStart of alt text is:\n$tv");
-	}
+        if( !is_string($aAlt) ) {
+            $tv = substr(var_export($aAlt,true),0,40);
+            JpGraphError::RaiseL(6025,$tv);
+            //('CSIM Alt text must be specified as a string.'."\nStart of alt text is:\n$tv");
+        }
         $this->csimalt=$aAlt;
     }
 
     function SetConstrain($aRow,$aType,$aColor='black',$aArrowSize=ARROW_S2,$aArrowType=ARROWT_SOLID) {
-	$this->constraints[] = new GanttConstraint($aRow, $aType, $aColor, $aArrowSize, $aArrowType);
+        $this->constraints[] = new GanttConstraint($aRow, $aType, $aColor, $aArrowSize, $aArrowType);
     }
 
     function SetConstrainPos($xt,$yt,$xb,$yb) {
-	$this->iConstrainPos = array($xt,$yt,$xb,$yb);
-    }
-
-    /*
-    function GetConstrain() {
-	return array($this->iConstrainRow,$this->iConstrainType);
-    }
-    */
-	
+        $this->iConstrainPos = array($xt,$yt,$xb,$yb);
+    }
+
     function GetMinDate() {
-	return $this->iStart;
+        return $this->iStart;
     }
 
     function GetMaxDate() {
-	return $this->iStart;
-    }
-	
+        return $this->iStart;
+    }
+
     function SetCaptionMargin($aMarg) {
-	$this->iCaptionMargin=$aMarg;
+        $this->iCaptionMargin=$aMarg;
     }
 
     function GetAbsHeight($aImg) {
-	return 0; 
-    }
-	
+        return 0;
+    }
+
     function GetLineNbr() {
-	return $this->iVPos;
+        return $this->iVPos;
     }
 
     function SetLabelLeftMargin($aOff) {
-	$this->iLabelLeftMargin=$aOff;
-    }		
+        $this->iLabelLeftMargin=$aOff;
+    }
 
     function StrokeActInfo($aImg,$aScale,$aYPos) {
-	$cols=array();
-	$aScale->actinfo->GetColStart($aImg,$cols,true);
-	$this->title->Stroke($aImg,$cols,$aYPos);		
+        $cols=array();
+        $aScale->actinfo->GetColStart($aImg,$cols,true);
+        $this->title->Stroke($aImg,$cols,$aYPos);
     }
 }
@@ -3026,5 +3129,5 @@
 //===================================================
 // CLASS Progress
-// Holds parameters for the progress indicator 
+// Holds parameters for the progress indicator
 // displyed within a bar
 //===================================================
@@ -3033,25 +3136,26 @@
     public $iPattern=GANTT_SOLID;
     public $iColor="black", $iFillColor='black';
-    public $iDensity=98, $iHeight=0.65; 
-	
+    public $iDensity=98, $iHeight=0.65;
+
     function Set($aProg) {
-	if( $aProg < 0.0 || $aProg > 1.0 )
-	    JpGraphError::RaiseL(6027);
-//("Progress value must in range [0, 1]");
-	$this->iProgress = $aProg;
-    }
-
-    function SetPattern($aPattern,$aColor="blue",$aDensity=98) {		
-	$this->iPattern = $aPattern;
-	$this->iColor = $aColor;
-	$this->iDensity = $aDensity;
+        if( $aProg < 0.0 || $aProg > 1.0 ) {
+        	JpGraphError::RaiseL(6027);
+        	//("Progress value must in range [0, 1]");
+        }
+        $this->iProgress = $aProg;
+    }
+
+    function SetPattern($aPattern,$aColor="blue",$aDensity=98) {
+        $this->iPattern = $aPattern;
+        $this->iColor = $aColor;
+        $this->iDensity = $aDensity;
     }
 
     function SetFillColor($aColor) {
-	$this->iFillColor = $aColor;
-    }
-	
+        $this->iFillColor = $aColor;
+    }
+
     function SetHeight($aHeight) {
-	$this->iHeight = $aHeight;
+        $this->iHeight = $aHeight;
     }
 }
@@ -3071,68 +3175,68 @@
     private $iStart=0; // 0=from left margin, 1=just along header
 
-    function HorizontalGridLine() {
-	$this->line = new LineProperty();
-	$this->line->SetColor('gray@0.4');
-	$this->line->SetStyle('dashed');
-    }
-    
+    function __construct() {
+        $this->line = new LineProperty();
+        $this->line->SetColor('gray@0.4');
+        $this->line->SetStyle('dashed');
+    }
+
     function Show($aShow=true) {
-	$this->iShow = $aShow;
+        $this->iShow = $aShow;
     }
 
     function SetRowFillColor($aColor1,$aColor2='') {
-	$this->iRowColor1 = $aColor1;
-	$this->iRowColor2 = $aColor2;
+        $this->iRowColor1 = $aColor1;
+        $this->iRowColor2 = $aColor2;
     }
 
     function SetStart($aStart) {
-	$this->iStart = $aStart;
+        $this->iStart = $aStart;
     }
 
     function Stroke($aImg,$aScale) {
-	
-	if( ! $this->iShow ) return;
-
-	// Get horizontal width of line
-	/*
-	$limst = $aScale->iStartDate;
-	$limen = $aScale->iEndDate;
-	$xt = round($aScale->TranslateDate($aScale->iStartDate));
-	$xb = round($aScale->TranslateDate($limen)); 
-	*/
-
-	if( $this->iStart === 0 ) {
-	    $xt = $aImg->left_margin-1;
-	}
-	else {
-	    $xt = round($aScale->TranslateDate($aScale->iStartDate))+1;
-	}
-
-	$xb = $aImg->width-$aImg->right_margin;
-
-	$yt = round($aScale->TranslateVertPos(0));
-	$yb = round($aScale->TranslateVertPos(1));	    
-	$height = $yb - $yt;
-
-	// Loop around for all lines in the chart
-	for($i=0; $i < $aScale->iVertLines; ++$i ) {
-	    $yb = $yt - $height;
-	    $this->line->Stroke($aImg,$xt,$yb,$xb,$yb);
-	    if( $this->iRowColor1 !== '' ) {
-		if( $i % 2 == 0 ) {
-		    $aImg->PushColor($this->iRowColor1);
-		    $aImg->FilledRectangle($xt,$yt,$xb,$yb);
-		    $aImg->PopColor();
-		}
-		elseif( $this->iRowColor2 !== '' ) {
-		    $aImg->PushColor($this->iRowColor2);
-		    $aImg->FilledRectangle($xt,$yt,$xb,$yb);
-		    $aImg->PopColor();
-		}
-	    }
-	    $yt = round($aScale->TranslateVertPos($i+1));
-	}
-	$yb = $yt - $height;
-	$this->line->Stroke($aImg,$xt,$yb,$xb,$yb);
+
+        if( ! $this->iShow ) return;
+
+        // Get horizontal width of line
+        /*
+        $limst = $aScale->iStartDate;
+        $limen = $aScale->iEndDate;
+        $xt = round($aScale->TranslateDate($aScale->iStartDate));
+        $xb = round($aScale->TranslateDate($limen));
+        */
+
+        if( $this->iStart === 0 ) {
+            $xt = $aImg->left_margin-1;
+        }
+        else {
+            $xt = round($aScale->TranslateDate($aScale->iStartDate))+1;
+        }
+
+        $xb = $aImg->width-$aImg->right_margin;
+
+        $yt = round($aScale->TranslateVertPos(0));
+        $yb = round($aScale->TranslateVertPos(1));
+        $height = $yb - $yt;
+
+        // Loop around for all lines in the chart
+        for($i=0; $i < $aScale->iVertLines; ++$i ) {
+            $yb = $yt - $height;
+            $this->line->Stroke($aImg,$xt,$yb,$xb,$yb);
+            if( $this->iRowColor1 !== '' ) {
+                if( $i % 2 == 0 ) {
+                    $aImg->PushColor($this->iRowColor1);
+                    $aImg->FilledRectangle($xt,$yt,$xb,$yb);
+                    $aImg->PopColor();
+                }
+                elseif( $this->iRowColor2 !== '' ) {
+                    $aImg->PushColor($this->iRowColor2);
+                    $aImg->FilledRectangle($xt,$yt,$xb,$yb);
+                    $aImg->PopColor();
+                }
+            }
+            $yt = round($aScale->TranslateVertPos($i+1));
+        }
+        $yb = $yt - $height;
+        $this->line->Stroke($aImg,$xt,$yb,$xb,$yb);
     }
 }
@@ -3151,235 +3255,257 @@
     private $iShadow=false,$iShadowColor="darkgray",$iShadowWidth=1,$iShadowFrame="black";
     private $iPattern=GANTT_RDIAG,$iPatternColor="blue",$iPatternDensity=95;
-//---------------
-// CONSTRUCTOR	
-    function GanttBar($aPos,$aLabel,$aStart,$aEnd,$aCaption="",$aHeightFactor=0.6) {
-	parent::GanttPlotObject();	
-	$this->iStart = $aStart;	
-	// Is the end date given as a date or as number of days added to start date?
-	if( is_string($aEnd) ) {
-	    // If end date has been specified without a time we will asssume
-	    // end date is at the end of that date
-	    if( strpos($aEnd,':') === false )
-		$this->iEnd = strtotime($aEnd)+SECPERDAY-1;
-	    else 
-		$this->iEnd = $aEnd;
-	}
-	elseif(is_int($aEnd) || is_float($aEnd) ) 
-	    $this->iEnd = strtotime($aStart)+round($aEnd*SECPERDAY);
-	$this->iVPos = $aPos;
-	$this->iHeightFactor = $aHeightFactor;
-	$this->title->Set($aLabel);
-	$this->caption = new TextProperty($aCaption);
-	$this->caption->Align("left","center");
-	$this->leftMark =new PlotMark();
-	$this->leftMark->Hide();
-	$this->rightMark=new PlotMark();
-	$this->rightMark->Hide();
-	$this->progress = new Progress();
-    }
-	
-//---------------
-// PUBLIC METHODS	
+    private $iBreakStyle=false, $iBreakLineStyle='dotted',$iBreakLineWeight=1;
+    //---------------
+    // CONSTRUCTOR
+    function __construct($aPos,$aLabel,$aStart,$aEnd,$aCaption="",$aHeightFactor=0.6) {
+        parent::__construct();
+        $this->iStart = $aStart;
+        // Is the end date given as a date or as number of days added to start date?
+        if( is_string($aEnd) ) {
+            // If end date has been specified without a time we will asssume
+            // end date is at the end of that date
+            if( strpos($aEnd,':') === false ) {
+            	$this->iEnd = strtotime($aEnd)+SECPERDAY-1;
+            }
+            else {
+            	$this->iEnd = $aEnd;
+            }
+        }
+        elseif(is_int($aEnd) || is_float($aEnd) ) {
+        	$this->iEnd = strtotime($aStart)+round($aEnd*SECPERDAY);
+        }
+        $this->iVPos = $aPos;
+        $this->iHeightFactor = $aHeightFactor;
+        $this->title->Set($aLabel);
+        $this->caption = new TextProperty($aCaption);
+        $this->caption->Align("left","center");
+        $this->leftMark =new PlotMark();
+        $this->leftMark->Hide();
+        $this->rightMark=new PlotMark();
+        $this->rightMark->Hide();
+        $this->progress = new Progress();
+    }
+
+    //---------------
+    // PUBLIC METHODS
     function SetShadow($aShadow=true,$aColor="gray") {
-	$this->iShadow=$aShadow;
-	$this->iShadowColor=$aColor;
-    }
-    
+        $this->iShadow=$aShadow;
+        $this->iShadowColor=$aColor;
+    }
+
+    function SetBreakStyle($aFlg=true,$aLineStyle='dotted',$aLineWeight=1) {
+    	$this->iBreakStyle = $aFlg;
+    	$this->iBreakLineStyle = $aLineStyle;
+    	$this->iBreakLineWeight = $aLineWeight;
+    }
+
     function GetMaxDate() {
-	return $this->iEnd;
-    }
-	
+        return $this->iEnd;
+    }
+
     function SetHeight($aHeight) {
-	$this->iHeightFactor = $aHeight;
+        $this->iHeightFactor = $aHeight;
     }
 
     function SetColor($aColor) {
-	$this->iFrameColor = $aColor;
+        $this->iFrameColor = $aColor;
     }
 
     function SetFillColor($aColor) {
-	$this->iFillColor = $aColor;
+        $this->iFillColor = $aColor;
     }
 
     function GetAbsHeight($aImg) {
-	if( is_int($this->iHeightFactor) || $this->leftMark->show || $this->rightMark->show ) {
-	    $m=-1;
-	    if( is_int($this->iHeightFactor) )
-		$m = $this->iHeightFactor;
-	    if( $this->leftMark->show ) 
-		$m = max($m,$this->leftMark->width*2);
-	    if( $this->rightMark->show ) 
-		$m = max($m,$this->rightMark->width*2);
-	    return $m;
-	}
-	else
-	    return -1;
-    }
-	
-    function SetPattern($aPattern,$aColor="blue",$aDensity=95) {		
-	$this->iPattern = $aPattern;
-	$this->iPatternColor = $aColor;
-	$this->iPatternDensity = $aDensity;
+        if( is_int($this->iHeightFactor) || $this->leftMark->show || $this->rightMark->show ) {
+            $m=-1;
+            if( is_int($this->iHeightFactor) )
+            	$m = $this->iHeightFactor;
+            if( $this->leftMark->show )
+            	$m = max($m,$this->leftMark->width*2);
+            if( $this->rightMark->show )
+            	$m = max($m,$this->rightMark->width*2);
+            return $m;
+        }
+        else
+        	return -1;
+    }
+
+    function SetPattern($aPattern,$aColor="blue",$aDensity=95) {
+        $this->iPattern = $aPattern;
+        $this->iPatternColor = $aColor;
+        $this->iPatternDensity = $aDensity;
     }
 
     function Stroke($aImg,$aScale) {
-	$factory = new RectPatternFactory();
-	$prect = $factory->Create($this->iPattern,$this->iPatternColor);
-	$prect->SetDensity($this->iPatternDensity);
-
-	// If height factor is specified as a float between 0,1 then we take it as meaning
-	// percetage of the scale width between horizontal line.
-	// If it is an integer > 1 we take it to mean the absolute height in pixels
-	if( $this->iHeightFactor > -0.0 && $this->iHeightFactor <= 1.1)
-	    $vs = $aScale->GetVertSpacing()*$this->iHeightFactor;
-	elseif(is_int($this->iHeightFactor) && $this->iHeightFactor>2 && $this->iHeightFactor < 200 )
-	    $vs = $this->iHeightFactor;
-	else
-	    JpGraphError::RaiseL(6028,$this->iHeightFactor);
-//("Specified height (".$this->iHeightFactor.") for gantt bar is out of range.");
-	
-	// Clip date to min max dates to show
-	$st = $aScale->NormalizeDate($this->iStart);
-	$en = $aScale->NormalizeDate($this->iEnd);
-	
-
-	$limst = max($st,$aScale->iStartDate);
-	$limen = min($en,$aScale->iEndDate);
-			
-	$xt = round($aScale->TranslateDate($limst));
-	$xb = round($aScale->TranslateDate($limen)); 
-	$yt = round($aScale->TranslateVertPos($this->iVPos)-$vs-($aScale->GetVertSpacing()/2-$vs/2));
-	$yb = round($aScale->TranslateVertPos($this->iVPos)-($aScale->GetVertSpacing()/2-$vs/2));
-	$middle = round($yt+($yb-$yt)/2);
-	$this->StrokeActInfo($aImg,$aScale,$middle);
-
-	// CSIM for title
-	if( ! empty($this->title->csimtarget) ) {
-	    $colwidth = $this->title->GetColWidth($aImg);
-	    $colstarts=array();
-	    $aScale->actinfo->GetColStart($aImg,$colstarts,true);
-	    $n = min(count($colwidth),count($this->title->csimtarget));
-	    for( $i=0; $i < $n; ++$i ) {
-		$title_xt = $colstarts[$i];
-		$title_xb = $title_xt + $colwidth[$i];
-		$coords = "$title_xt,$yt,$title_xb,$yt,$title_xb,$yb,$title_xt,$yb";
-
-		if( ! empty($this->title->csimtarget[$i]) ) {
-		    $this->csimarea .= "<area shape=\"poly\" coords=\"$coords\" href=\"".$this->title->csimtarget[$i]."\"";
-		    
-		    if( ! empty($this->title->csimwintarget[$i]) ) {
-			$this->csimarea .= "target=\"".$this->title->csimwintarget[$i]."\" ";
-		    }
-		    
-		    if( ! empty($this->title->csimalt[$i]) ) {
-			$tmp = $this->title->csimalt[$i];
-			$this->csimarea .= " title=\"$tmp\" alt=\"$tmp\" ";
-		    }
-		    $this->csimarea .= " />\n";
-		}
-	    }
-	}
-	
-	// Check if the bar is totally outside the current scale range
-	if( $en <  $aScale->iStartDate || $st > $aScale->iEndDate )
-		return;
-			
-
-	// Remember the positions for the bar
-	$this->SetConstrainPos($xt,$yt,$xb,$yb);
-		
-	$prect->ShowFrame(false);
-	$prect->SetBackground($this->iFillColor);
-	if( $this->iShadow ) {
-	    $aImg->SetColor($this->iFrameColor);
-	    $aImg->ShadowRectangle($xt,$yt,$xb,$yb,$this->iFillColor,$this->iShadowWidth,$this->iShadowColor);				
-	    $prect->SetPos(new Rectangle($xt+1,$yt+1,$xb-$xt-$this->iShadowWidth-2,$yb-$yt-$this->iShadowWidth-2));				
-	    $prect->Stroke($aImg);
-	}
-	else {	
-	    $prect->SetPos(new Rectangle($xt,$yt,$xb-$xt+1,$yb-$yt+1));				
-	    $prect->Stroke($aImg);
-	    $aImg->SetColor($this->iFrameColor);
-	    $aImg->Rectangle($xt,$yt,$xb,$yb);
-	}
-
-	// CSIM for bar
-	if( ! empty($this->csimtarget) ) {
-
-	    $coords = "$xt,$yt,$xb,$yt,$xb,$yb,$xt,$yb";
-	    $this->csimarea .= "<area shape=\"poly\" coords=\"$coords\" href=\"".$this->csimtarget."\"";
-	    
-	    if( !empty($this->csimwintarget) ) {
-		$this->csimarea .= " target=\"".$this->csimwintarget."\" ";
-	    }
-
-	    if( $this->csimalt != '' ) {
-		$tmp = $this->csimalt;
-		$this->csimarea .= " title=\"$tmp\" alt=\"$tmp\" ";
-	    }
-	    $this->csimarea .= " />\n";
-	}
-
-	// Draw progress bar inside activity bar
-	if( $this->progress->iProgress > 0 ) {
-		
-	    $xtp = $aScale->TranslateDate($st);
-	    $xbp = $aScale->TranslateDate($en);
-	    $len = ($xbp-$xtp)*$this->progress->iProgress;
-
-	    $endpos = $xtp+$len;
-	    if( $endpos > $xt ) {
-
-		// Take away the length of the progress that is not visible (before the start date)
-		$len -= ($xt-$xtp); 
-
-		// Is the the progress bar visible after the start date?
-		if( $xtp < $xt ) 
-		    $xtp = $xt;
-		
-		// Make sure that the progess bar doesn't extend over the end date
-		if( $xtp+$len-1 > $xb )
-		    $len = $xb - $xtp ;
-		
-		$prog = $factory->Create($this->progress->iPattern,$this->progress->iColor);
-		$prog->SetDensity($this->progress->iDensity);
-		$prog->SetBackground($this->progress->iFillColor);
-	    	$barheight = ($yb-$yt+1);
-		if( $this->iShadow ) 
-		    $barheight -= $this->iShadowWidth;
-		$progressheight = floor($barheight*$this->progress->iHeight);
-		$marg = ceil(($barheight-$progressheight)/2);
-	    	$pos = new Rectangle($xtp,$yt + $marg, $len,$barheight-2*$marg);
-		$prog->SetPos($pos);
-		$prog->Stroke($aImg);
-	    }
-	}
-	
-	// We don't plot the end mark if the bar has been capped
-	if( $limst == $st ) {
-	    $y = $middle;
-	    // We treat the RIGHT and LEFT triangle mark a little bi
-	    // special so that these marks are placed right under the
-	    // bar.
-	    if( $this->leftMark->GetType() == MARK_LEFTTRIANGLE ) {
-		$y = $yb ; 
-	    }
-	    $this->leftMark->Stroke($aImg,$xt,$y);
-	}
-	if( $limen == $en ) {
-	    $y = $middle;
-	    // We treat the RIGHT and LEFT triangle mark a little bi
-	    // special so that these marks are placed right under the
-	    // bar.
-	    if( $this->rightMark->GetType() == MARK_RIGHTTRIANGLE ) {
-		$y = $yb ; 
-	    }
-	    $this->rightMark->Stroke($aImg,$xb,$y);
-	    
-	    $margin = $this->iCaptionMargin;
-	    if( $this->rightMark->show ) 
-	    	$margin += $this->rightMark->GetWidth();
-	    $this->caption->Stroke($aImg,$xb+$margin,$middle);		
-	}
+        $factory = new RectPatternFactory();
+        $prect = $factory->Create($this->iPattern,$this->iPatternColor);
+        $prect->SetDensity($this->iPatternDensity);
+
+        // If height factor is specified as a float between 0,1 then we take it as meaning
+        // percetage of the scale width between horizontal line.
+        // If it is an integer > 1 we take it to mean the absolute height in pixels
+        if( $this->iHeightFactor > -0.0 && $this->iHeightFactor <= 1.1)
+        	$vs = $aScale->GetVertSpacing()*$this->iHeightFactor;
+        elseif(is_int($this->iHeightFactor) && $this->iHeightFactor>2 && $this->iHeightFactor < 200 )
+        	$vs = $this->iHeightFactor;
+        else {
+        	JpGraphError::RaiseL(6028,$this->iHeightFactor);
+        	//	("Specified height (".$this->iHeightFactor.") for gantt bar is out of range.");
+        }
+
+        // Clip date to min max dates to show
+        $st = $aScale->NormalizeDate($this->iStart);
+        $en = $aScale->NormalizeDate($this->iEnd);
+
+        $limst = max($st,$aScale->iStartDate);
+        $limen = min($en,$aScale->iEndDate);
+
+        $xt = round($aScale->TranslateDate($limst));
+        $xb = round($aScale->TranslateDate($limen));
+        $yt = round($aScale->TranslateVertPos($this->iVPos)-$vs-($aScale->GetVertSpacing()/2-$vs/2));
+        $yb = round($aScale->TranslateVertPos($this->iVPos)-($aScale->GetVertSpacing()/2-$vs/2));
+        $middle = round($yt+($yb-$yt)/2);
+        $this->StrokeActInfo($aImg,$aScale,$middle);
+
+        // CSIM for title
+        if( ! empty($this->title->csimtarget) ) {
+            $colwidth = $this->title->GetColWidth($aImg);
+            $colstarts=array();
+            $aScale->actinfo->GetColStart($aImg,$colstarts,true);
+            $n = min(count($colwidth),count($this->title->csimtarget));
+            for( $i=0; $i < $n; ++$i ) {
+                $title_xt = $colstarts[$i];
+                $title_xb = $title_xt + $colwidth[$i];
+                $coords = "$title_xt,$yt,$title_xb,$yt,$title_xb,$yb,$title_xt,$yb";
+
+                if( ! empty($this->title->csimtarget[$i]) ) {
+                    $this->csimarea .= "<area shape=\"poly\" coords=\"$coords\" href=\"".$this->title->csimtarget[$i]."\"";
+
+                    if( ! empty($this->title->csimwintarget[$i]) ) {
+                        $this->csimarea .= "target=\"".$this->title->csimwintarget[$i]."\" ";
+                    }
+
+                    if( ! empty($this->title->csimalt[$i]) ) {
+                        $tmp = $this->title->csimalt[$i];
+                        $this->csimarea .= " title=\"$tmp\" alt=\"$tmp\" ";
+                    }
+                    $this->csimarea .= " />\n";
+                }
+            }
+        }
+
+        // Check if the bar is totally outside the current scale range
+        if( $en <  $aScale->iStartDate || $st > $aScale->iEndDate )
+        	return;
+
+
+        // Remember the positions for the bar
+        $this->SetConstrainPos($xt,$yt,$xb,$yb);
+
+
+
+        $prect->ShowFrame(false);
+        $prect->SetBackground($this->iFillColor);
+        if( $this->iBreakStyle ) {
+        	$aImg->SetColor($this->iFrameColor);
+        	$olds = $aImg->SetLineStyle($this->iBreakLineStyle);
+        	$oldw = $aImg->SetLineWeight($this->iBreakLineWeight);
+        	$aImg->StyleLine($xt,$yt,$xb,$yt);
+        	$aImg->StyleLine($xt,$yb,$xb,$yb);
+        	$aImg->SetLineStyle($olds);
+        	$aImg->SetLineWeight($oldw);
+        }
+        else {
+	        if( $this->iShadow ) {
+	            $aImg->SetColor($this->iFrameColor);
+	            $aImg->ShadowRectangle($xt,$yt,$xb,$yb,$this->iFillColor,$this->iShadowWidth,$this->iShadowColor);
+	            $prect->SetPos(new Rectangle($xt+1,$yt+1,$xb-$xt-$this->iShadowWidth-2,$yb-$yt-$this->iShadowWidth-2));
+	            $prect->Stroke($aImg);
+	        }
+	        else {
+	            $prect->SetPos(new Rectangle($xt,$yt,$xb-$xt+1,$yb-$yt+1));
+	            $prect->Stroke($aImg);
+	            $aImg->SetColor($this->iFrameColor);
+	            $aImg->Rectangle($xt,$yt,$xb,$yb);
+	        }
+        }
+        // CSIM for bar
+        if( ! empty($this->csimtarget) ) {
+
+            $coords = "$xt,$yt,$xb,$yt,$xb,$yb,$xt,$yb";
+            $this->csimarea .= "<area shape=\"poly\" coords=\"$coords\" href=\"".$this->csimtarget."\"";
+
+            if( !empty($this->csimwintarget) ) {
+                $this->csimarea .= " target=\"".$this->csimwintarget."\" ";
+            }
+
+            if( $this->csimalt != '' ) {
+                $tmp = $this->csimalt;
+                $this->csimarea .= " title=\"$tmp\" alt=\"$tmp\" ";
+            }
+            $this->csimarea .= " />\n";
+        }
+
+        // Draw progress bar inside activity bar
+        if( $this->progress->iProgress > 0 ) {
+
+            $xtp = $aScale->TranslateDate($st);
+            $xbp = $aScale->TranslateDate($en);
+            $len = ($xbp-$xtp)*$this->progress->iProgress;
+
+            $endpos = $xtp+$len;
+            if( $endpos > $xt ) {
+
+                // Take away the length of the progress that is not visible (before the start date)
+                $len -= ($xt-$xtp);
+
+                // Is the the progress bar visible after the start date?
+                if( $xtp < $xt )
+                $xtp = $xt;
+
+                // Make sure that the progess bar doesn't extend over the end date
+                if( $xtp+$len-1 > $xb )
+                $len = $xb - $xtp ;
+
+                $prog = $factory->Create($this->progress->iPattern,$this->progress->iColor);
+                $prog->SetDensity($this->progress->iDensity);
+                $prog->SetBackground($this->progress->iFillColor);
+                $barheight = ($yb-$yt+1);
+                if( $this->iShadow )
+                	$barheight -= $this->iShadowWidth;
+                $progressheight = floor($barheight*$this->progress->iHeight);
+                $marg = ceil(($barheight-$progressheight)/2);
+                $pos = new Rectangle($xtp,$yt + $marg, $len,$barheight-2*$marg);
+                $prog->SetPos($pos);
+                $prog->Stroke($aImg);
+            }
+        }
+
+        // We don't plot the end mark if the bar has been capped
+        if( $limst == $st ) {
+            $y = $middle;
+            // We treat the RIGHT and LEFT triangle mark a little bi
+            // special so that these marks are placed right under the
+            // bar.
+            if( $this->leftMark->GetType() == MARK_LEFTTRIANGLE ) {
+                $y = $yb ;
+            }
+            $this->leftMark->Stroke($aImg,$xt,$y);
+        }
+        if( $limen == $en ) {
+            $y = $middle;
+            // We treat the RIGHT and LEFT triangle mark a little bi
+            // special so that these marks are placed right under the
+            // bar.
+            if( $this->rightMark->GetType() == MARK_RIGHTTRIANGLE ) {
+                $y = $yb ;
+            }
+            $this->rightMark->Stroke($aImg,$xb,$y);
+
+            $margin = $this->iCaptionMargin;
+            if( $this->rightMark->show )
+            	$margin += $this->rightMark->GetWidth();
+            $this->caption->Stroke($aImg,$xb+$margin,$middle);
+        }
     }
 }
